package de.firstdata.ipg.api.client.subsequenttransaction.object;

import de.firstdata.ipg.api.client.subsequenttransaction.IPGApiSubsequentTransaction;
import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.schema.Options;
import de.firstdata.ipg.api.schema.Payment;
import de.firstdata.ipg.api.schema.SubsequentTransaction;
import de.firstdata.ipg.api.schema.SubsequentTransactionType;

public abstract class IPGApiSubsequentTransactionObject extends SubsequentTransaction implements IPGApiSubsequentTransaction {

	protected IPGApiSubsequentTransactionObject(final Amount amount, final SubsequentTransactionType transactionType) {
		this.setTransactionType(transactionType);
		setPayment(amount);
	}

	@Override
	public Payment getPayment() {
		if (this.payment == null) {
			this.payment = new Payment();
		}
		return this.payment;
	}

	protected void setPayment(final Amount amount) {
		if (amount == null) {
			return;
		}
		getPayment();
		this.payment.setSubTotal(amount.subTotal);
		this.payment.setValueAddedTax(amount.valueAddedTax);
		this.payment.setDeliveryAmount(amount.deliveryAmount);
		this.payment.setChargeTotal(amount.total);
		this.payment.setCurrency(amount.currency);
	}

	@Override
	public void setStoreId(final String storeId) {
		getOptions().setStoreId(storeId);
	}

	@Override
	public Options getOptions() {
		if (this.options == null) {
			this.options = new Options();
		}
		return this.options;
	}
}
