package de.firstdata.ipg.api.client.subsequenttransaction.object;

import de.firstdata.ipg.api.client.subsequenttransaction.VoidSubsequentTransaction;
import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.schema.SubsequentTransactionType;

public class VoidSubsequentTransactionObject extends IPGApiSubsequentTransactionObject implements VoidSubsequentTransaction {

	protected VoidSubsequentTransactionObject(final Amount amount) {
		super(amount, SubsequentTransactionType.VOID);
	}

	public VoidSubsequentTransactionObject(final Amount amount, final String orderId, final String tDate) {
		this(amount);
		this.setOrderId(orderId);
		this.setTDate(tDate);
	}

	public VoidSubsequentTransactionObject(final Amount amount, final Long ipgTransactionId) {
		this(amount);
		this.setIpgTransactionId(ipgTransactionId);
	}

	public VoidSubsequentTransactionObject(final Amount amount, final String referencedMerchantTransactionId) {
		this(amount);
		this.setReferencedMerchantTransactionId(referencedMerchantTransactionId);
	}
}
