package de.firstdata.ipg.api.client.transaction;

import java.math.BigDecimal;

public class Amount {

	public final BigDecimal subTotal;

	public final BigDecimal valueAddedTax;

	public final BigDecimal localTax;

	public final BigDecimal deliveryAmount;

	public final BigDecimal cashbackAmount;

	public final BigDecimal tipAmount;

	public final BigDecimal total;

	public final String currency;

	public Amount(final BigDecimal subTotal, final BigDecimal valueAddedTax, final BigDecimal localTax, final BigDecimal deliveryAmount,
			final BigDecimal cashbackAmount, final BigDecimal tipAmount, final BigDecimal total, final String currency) {
		this.subTotal = subTotal;
		this.valueAddedTax = valueAddedTax;
		this.localTax = localTax;
		this.deliveryAmount = deliveryAmount;
		this.cashbackAmount = cashbackAmount;
		this.tipAmount = tipAmount;
		this.total = total;
		this.currency = currency;
	}

	public Amount(final String subTotal, final String valueAddedTax, final String deliveryAmount, final String cashbackAmount, final String tipAmount,
			final String total, final String currency) {
		this(subTotal == null ? null : new BigDecimal(subTotal), valueAddedTax == null ? null : new BigDecimal(valueAddedTax), null,
				deliveryAmount == null ? null : new BigDecimal(deliveryAmount), cashbackAmount == null ? null : new BigDecimal(cashbackAmount),
				tipAmount == null ? null : new BigDecimal(tipAmount), new BigDecimal(total), currency);
	}

	public Amount(final BigDecimal subTotal, final BigDecimal valueAddedTax, final BigDecimal deliveryAmount, final BigDecimal total, final String currency) {
		this(subTotal, valueAddedTax, null, deliveryAmount, null, null, total, currency);
	}

	public Amount(final String subTotal, final String valueAddedTax, final String deliveryAmount, final String total, final String currency) {
		this(subTotal, valueAddedTax, deliveryAmount, null, null, total, currency);
	}

	public Amount(final BigDecimal total, final String currency) {
		this(null, null, null, null, null, null, total, currency);
	}

	public Amount(final String total, final String currency) {
		this(new BigDecimal(total), currency);
	}
}
