package de.firstdata.ipg.api.client.transaction.alipay.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.schema.AlipayDomesticInformation;
import de.firstdata.ipg.api.schema.AlipayPaymentInformation;
import de.firstdata.ipg.api.schema.AlipayTxType;

public abstract class AlipayTransactionObject extends IPGApiTransactionObject {

	protected AlipayTransactionObject(final String type, final Amount amount, final String orderId) {
		super(amount, null, null, orderId);
		getAlipayTxType().setType(type);
	}

	@Override
	public String getType() {
		return getAlipayTxType().getType();
	}

	@Override
	public void setStoreId(final String storeId) {
		getAlipayTxType().setStoreId(storeId);
	}

	@Override
	public AlipayPaymentInformation getAlipayPaymentInformation() {
		if (this.alipayPaymentInformation == null) {
			this.alipayPaymentInformation = new AlipayPaymentInformation();
		}
		return this.alipayPaymentInformation;
	}

	@Override
	public AlipayDomesticInformation getAlipayDomesticInformation() {
		if (this.alipayDomesticInformation == null) {
			this.alipayDomesticInformation = new AlipayDomesticInformation();
		}
		return this.alipayDomesticInformation;
	}

	@Override
	public AlipayTxType getAlipayTxType() {
		if (this.alipayTxType == null) {
			this.alipayTxType = new AlipayTxType();
		}
		return this.alipayTxType;
	}

	@Override
	public String getStore() {
		return getAlipayTxType().getStoreId();
	}
}
