package de.firstdata.ipg.api.client.transaction.creditcard;

import de.firstdata.ipg.api.client.transaction.creditcard.setter.AdditionalTransactionDataSetter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.InstallmentSetter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.MCC6012Setter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.PaymentFacilitatorSetter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.Secure3DSetter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.SubMerchantSetter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.SubMerchantSplitSetter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.UpopSecurePlusSetter;
import de.firstdata.ipg.api.client.transaction.creditcard.setter.WalletSetter;
import de.firstdata.ipg.api.client.transaction.setter.BasketSetter;
import de.firstdata.ipg.api.client.transaction.setter.BillingSetter;
import de.firstdata.ipg.api.client.transaction.setter.InquiryRateReferenceSetter;
import de.firstdata.ipg.api.client.transaction.setter.PaymentSetter;
import de.firstdata.ipg.api.client.transaction.setter.ShippingSetter;
import de.firstdata.ipg.api.client.transaction.setter.TransactionDetailsSetter;
import de.firstdata.ipg.api.schema.CardAccountType;
import de.firstdata.ipg.api.schema.CardFunctionType;
import de.firstdata.ipg.api.schema.RecurringType;
import de.firstdata.ipg.api.schema.SCAExemptionIndicators;

public interface CCSaleTransaction extends CCTransaction, AdditionalTransactionDataSetter, BasketSetter, BillingSetter, InstallmentSetter, MCC6012Setter,
		PaymentSetter, PaymentFacilitatorSetter, SubMerchantSetter, SubMerchantSplitSetter, Secure3DSetter, UpopSecurePlusSetter, ShippingSetter,
		TransactionDetailsSetter, InquiryRateReferenceSetter, WalletSetter {

	void setTerminalID(final String terminalID);

	void setExternalMerchantID(final String terminalID);

	void setMcc(final Integer terminalID);

	void setCardFunction(final CardFunctionType cardFunction);

	void setCardAccount(final CardAccountType cardAccount);

	void setRecurringType(final RecurringType recurringType);

	void setStandIn(final boolean isStandin);

	void setTDate(final String tDate);

	void setSCAExemptionIndicators(final SCAExemptionIndicators value);

	void setVisaMerchantIdentifier(final String value);
}
