package de.firstdata.ipg.api.client.transaction.creditcard.object;

import de.firstdata.ipg.api.client.IPGApiClient;
import de.firstdata.ipg.api.client.IPGApiResult;
import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.creditcard.CCPostAuthTransaction;

/**
 * This class represents a <i>PostAuth</i> transaction and allows for setting
 * its optional attributes by calling the appropriate <code>setter</code>
 * methods. An instance of this class is created when calling
 * {@link IPGApiClient#createPostAuthTransaction(double, String)}.
 *
 * @author Andreas Schmid
 */
public final class CCPostAuthTransactionObject extends CCTransactionObject implements CCPostAuthTransaction {

	/**
	 * creates a <i>PostAuth</i> transaction with the minimum set of parameters
	 * - note that you can add optional fields by calling the appropriate
	 * <code>setter</code> methods on the returned
	 * {@link CCPostAuthTransactionObject} instance
	 *
	 *
	 * @param orderId
	 *            the order ID this transaction refers to and which is contained
	 *            in an {@link IPGApiResult} instance returned as result to a
	 *            successful {@link CCPostAuthTransactionObject} - call
	 *            {@link IPGApiResult#getOrderId()} for accessing this order ID
	 */
	public CCPostAuthTransactionObject(final Amount amount, final String orderId) {
		super("postAuth", amount, null, null, null, orderId);
	}
}
