package de.firstdata.ipg.api.client.transaction.cupdomestic.object;

import java.math.BigDecimal;
import java.net.URI;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.cupdomestic.CUPDomesticSaleTransaction;
import de.firstdata.ipg.api.schema.CUPDomesticInformation;

/**
 * For domestic CUP sale transactions via ChinaPnR
 */
public class CUPDomesticSaleTransactionObject extends CUPDomesticTransactionObject implements CUPDomesticSaleTransaction {

	private static final String SALE = "sale";

	public CUPDomesticSaleTransactionObject(final Amount amount, final String orderId, final String productCode, final int productQuantity,
			final BigDecimal productPrice, final String productDescription, final URI redirectUrl) {
		super(amount, orderId);
		final CUPDomesticInformation cupDomesticInformation = getCUPDomesticInformation();
		cupDomesticInformation.setProductCode(productCode);
		cupDomesticInformation.setProductQuantity(productQuantity);
		cupDomesticInformation.setProductPrice(productPrice);
		cupDomesticInformation.setProductDescription(productDescription);
		cupDomesticInformation.setRedirectUrl(redirectUrl.toString());
	}

	@Override
	public void setCustomerId(final String customerId) {
		getCUPDomesticInformation().setCustomerId(customerId);
	}

	@Override
	public void setBankId(final String bankId) {
		getCUPDomesticInformation().setBankId(bankId);
	}

	@Override
	public String getType() {
		return SALE;
	}

	@Override
	public CUPDomesticInformation getCUPDomesticInformation() {
		if (this.cupDomesticInformation == null) {
			this.cupDomesticInformation = new CUPDomesticInformation();
		}
		return this.cupDomesticInformation;
	}
}
