package de.firstdata.ipg.api.client.transaction.softwareexpress.object;

import javax.annotation.Nonnull;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.client.transaction.softwareexpress.SoftwareExpressTransaction;
import de.firstdata.ipg.api.schema.BoletoTxType;
import de.firstdata.ipg.api.schema.Transaction;

/**
 * base abstract class for Boleto transaction which implements necessary methods
 * for all transaction types
 *
 * @author f9yyvjx
 */
public abstract class BoletoTransactionObject extends IPGApiTransactionObject implements SoftwareExpressTransaction {

	protected BoletoTransactionObject(final String type, final Amount amount, final String orderId, final String authorizer) {
		super(amount, null, null, orderId);
		setAuthorizerID(authorizer);
		getBoletoTxType().setType(type);
	}

	@Override
	public String getType() {
		return getBoletoTxType().getType();
	}

	/**
	 * see {@link Transaction#getBoletoTxType()}
	 */
	@Override
	public @Nonnull BoletoTxType getBoletoTxType() {
		if (this.boletoTxType == null) {
			this.boletoTxType = new BoletoTxType();
		}
		return this.boletoTxType;
	}

	@Override
	public void setStoreId(final String storeId) {
		getBoletoTxType().setStoreId(storeId);
	}

	@Override
	public String getStore() {
		return getBoletoTxType().getStoreId();
	}
}
