package de.firstdata.ipg.api.client.transaction.softwareexpress.object;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.client.transaction.softwareexpress.SoftwareExpressTransaction;
import de.firstdata.ipg.api.schema.PixTxType;
import de.firstdata.ipg.api.schema.Transaction;

public abstract class PixTransactionObject extends IPGApiTransactionObject implements SoftwareExpressTransaction {

	protected PixTransactionObject(@Nonnull final String type, @Nonnull final Amount amount, @Nonnull final String orderId, @Nonnull final String authorizer) {
		super(amount, null, null, orderId);
		setAuthorizerID(authorizer);
		getPixTxType().setType(type);
	}

	@Override
	public String getType() {
		return getPixTxType().getType();
	}

	/**
	 * see {@link Transaction#getPixTxType()}
	 */
	@Override
	@Nonnull
	public PixTxType getPixTxType() {
		PixTxType localPixTxType = this.pixTxType;
		if (localPixTxType == null) {
			localPixTxType = new PixTxType();
			this.pixTxType = localPixTxType;
		}
		return localPixTxType;
	}

	@Override
	public void setStoreId(@CheckForNull final String storeId) {
		getPixTxType().setStoreId(storeId);
	}

	@Override
	@CheckForNull
	public String getStore() {
		return getPixTxType().getStoreId();
	}
}
