//
// This file was generated by the Eclipse Implementation of JAXB, v2.3.6 
// See https://eclipse-ee4j.github.io/jaxb-ri 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2024.02.27 at 02:34:14 PM CET 
//


package de.firstdata.ipg.api.schema;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for MerchantInitiatedIndicator.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <pre>
 * &lt;simpleType name="MerchantInitiatedIndicator"&gt;
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string"&gt;
 *     &lt;enumeration value="UNSCHEDULED_CREDENTIAL_ON_FILE"/&gt;
 *     &lt;enumeration value="STANDING_ORDER"/&gt;
 *     &lt;enumeration value="SUBSCRIPTION"/&gt;
 *     &lt;enumeration value="INSTALLMENT"/&gt;
 *     &lt;enumeration value="PARTIAL_SHIPMENT"/&gt;
 *     &lt;enumeration value="DELAYED_CHARGE"/&gt;
 *     &lt;enumeration value="NO_SHOW_CHARGE"/&gt;
 *     &lt;enumeration value="RESUBMISSION"/&gt;
 *   &lt;/restriction&gt;
 * &lt;/simpleType&gt;
 * </pre>
 * 
 */
@XmlType(name = "MerchantInitiatedIndicator")
@XmlEnum
public enum MerchantInitiatedIndicator {


    /**
     * A transaction made pursuant to an agreement between a cardholder and a merchant, whereby the cardholder authorizes the merchant to store and
     * 						use the cardholder’s account data to initiate one or more future transactions. The transaction can be for a fixed or variable amount but does not occur at
     * 						regular intervals on a scheduled date.
     * 					
     * 
     */
    UNSCHEDULED_CREDENTIAL_ON_FILE,

    /**
     * A transaction made pursuant to an agreement between a cardholder and a merchant, whereby the cardholder authorizes the merchant to store and use
     * 						the cardholder’s account data for a transaction that must occur at regularly scheduled
     * 						intervals for a variable amount, as specified in the agreement.
     * 					
     * 
     */
    STANDING_ORDER,

    /**
     * A transaction made pursuant to an agreement between a cardholder and a merchant, whereby the cardholder authorizes the merchant to store and use the cardholder’s account data for a transaction that must occur at regularly scheduled intervals for a fixed amount, as specified in the agreement. The subscription agreement may include an allowance for introductory pricing or for price changes to occur from time to time.
     * 
     */
    SUBSCRIPTION,

    /**
     * A transaction in a series of transactions made pursuant to an agreement between a cardholder and a merchant, whereby the cardholder authorizes the merchant to store the cardholder’s account data for use by the merchant to initiate one or more future transactions for a known amount over a specified duration based on a single purchase.
     * 
     */
    INSTALLMENT,

    /**
     * Occurs when an agreed quantity of goods ordered through e-commerce are not all available for shipment at the time of purchase. Each shipment is a separate transaction
     * 
     */
    PARTIAL_SHIPMENT,

    /**
     * AKA: related charge. An additional account charge after initial services have been rendered and payment has been processed.
     * 
     */
    DELAYED_CHARGE,

    /**
     * A penalty charged according to the merchant’s cancellation policy
     * 
     */
    NO_SHOW_CHARGE,

    /**
     * Previous attempt to obtain authorization for a transaction has been declined but the issuer’s response does not prohibit the merchant from trying again later.
     * 
     */
    RESUBMISSION;

    public String value() {
        return name();
    }

    public static MerchantInitiatedIndicator fromValue(String v) {
        return valueOf(v);
    }

}
